<?php
/**
 * Copyright 1999 - 2003 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup bug
 * @module bug_ins
 * @package bug
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';
 include_once 'location.pinc';
 include_once 'product.pinc';
 include_once 'task.pinc';
 include_once 'timetrack.pinc';
 include_once 'mail.pinc';


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bugtracking","new");
 loadmodule("bugtracking");


 $gotourl = "bug_new.php";
 $msg = "";

 $b = new bug($dbconn);
 if ( isset($_POST['id']) ) {
   $gotourl= addUrlParameter($gotourl,"id=". $_POST['id'],true);
   $b = $b->read($_POST['id'],$b);
   $b->read_bughistory();
 }
 $b->newdesc = "";

 if ( empty($_POST['name']) || !isset($_POST['name']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugID']) ."<br>";
 } else {
   $name = StripSlashes($_POST['name']);
   $gotourl= addUrlParameter($gotourl,"name=". UrlEncode($name),true);
 }

 if ( (empty($_POST['description']) || !isset($_POST['description']) ) && ($b->id < 0 )) {
   $msg .= sprintf($lang['Err0009'],$lang['BugAdditional']) ."<br>";
 } else {
   $description = StripSlashes($_POST['description']);
   $gotourl= addUrlParameter($gotourl,"description=". UrlEncode($description),true);
 }

 if ( empty($_POST['short']) || !isset($_POST['short']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugShort']) ."<br>";
 } else {
   $short = StripSlashes($_POST['short']);
   $gotourl= addUrlParameter($gotourl,"short=". UrlEncode($short),true);
 }

 if ( isset($_POST['pid']) ) {
   $gotourl= addUrlParameter($gotourl,"pid=". $_POST['pid'],true);
   $oldparent = $b->parent;
   $b->setParent(getObject($dbconn,$_POST['pid']));
 } else {
   $msg .= sprintf($lang['Err0009'],$lang['Product']) ."<br>";
 }

 if ( empty($_POST['state']) || !isset($_POST['state']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugState']) ."<br>";
 } else {
   $state = $_POST['state'];
   $gotourl= addUrlParameter($gotourl,"state=". $state,true);
 }
 if ( empty($_POST['class']) || !isset($_POST['class']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugClass']) ."<br>";
 } else {
   $class = $_POST['class'];
   $gotourl= addUrlParameter($gotourl,"class=". $class,true);
 }

 if ( empty($_POST['sfn']) || !isset($_POST['sfn']) ) {
   if ( isset($_POST['sid']) ) {
     $solver = getObject($dbconn,$_POST['sid']);
   } else {
     $msg .= sprintf($lang['Err0009'],$lang['BugAssignedTo']) ."<br>";
   }
 } else {
   if ($b->solver->getFullName() == $_POST['sfn']) {
     # Keeep an existing solver even if we cannot see/use it
	 $solver = $b->solver;
   } else {
     $solver = check_field($_POST['sfn'],"sfn","sl");
   }
 }

 # other modules
 $msg .= module_parseforms($current_user,$b,$gotourl);

 if ( $msg != "" ) {
   $gotourl = addMessage($gotourl,$msg,true);
   $gotourl = addSessionKey($gotourl,true);
   Header("Status: 302 Moved Temporarily");
   Header("Location:". getBaseUrl() . $gotourl);
   return;
 }

 #
 # Old Bug
 #
 if ( $b->id > 0 )  {
   $newlines = "";
   if ( !empty($description) ) {
     $newlines =  myentities($description);
   }
   #
   # Solver Change
   #
   if ( $b->solver->id != $solver->id ) {
     if ( ($solver->id > 0) && ($b->solver->id > 0 ) ) {
       $newlines = sprintf("<b>". $lang['BugAssignedTo'] .": <i>%s</i> &#8594; <i>%s</i></b>\n%s" ,$b->solver->getFullName(),$solver->getFullName() , $newlines);
     } else {
       $newlines = sprintf("<b>Solver changed</b>\n%s",$newlines);
     }
     $b->setSolver($solver);
   }
   #
   # Parent Change
   #
   if (($oldparent != -1) && ($b->parent->id != $oldparent->id) ) {
     $newlines = sprintf("<b>". $lang['BugReference'] .": <i>%s</i> &#8594; <i>%s</i></b>\n%s" ,$oldparent->getFullName(),$b->parent->getFullName() , $newlines);
   }
   #
   # State Change
   #
   if ( $b->state != $state ) {
     $newlines = sprintf("<b>". $lang['BugState'] .": <i>%s</i> &#8594; <i>%s</i></b>\n%s" ,$b->getState(),$b->getState($state) , $newlines);
   }
   #
   # Class Change
   #
   if ( $b->class != $class ) {
     $newlines = sprintf("<b>". $lang['BugClass'] .":<i>%s</i> &#8594; <i>%s</i></b>\n%s" ,$b->getClass(),$b->getClass($class) , $newlines);
   }
   if ( $b->short != $short ) {
     $newlines = sprintf("<b>". $lang['BugShort'] .": <i>%s</i> &#8594; <i>%s</i></b>\n%s" ,$b->short,$short , $newlines);
   }
   $b->newdesc = $newlines;
 } else {
   #
   # New Bug
   #
   $b->bughist[0] = new bugdata($dbconn);
   $b->bughist[0]->description = myentities($description);

   if ( $b->parent->getType() == "product" ) {
     $b->parent->readroles();
     if ( count($b->parent->role[PROD_ROLE_MANAGER]) > 0 ) {
       $b->setSolver(current($b->parent->role[PROD_ROLE_MANAGER]));
     } else if ( count($b->parent->role[PROD_ROLE_MANAGER2]) > 0 ) {
       $b->setSolver(current($b->parent->role[PROD_ROLE_MANAGER2]));
     } else {
       $b->setSolver($current_user);
     }
   } else if ( $b->parent->getType() == "installation" ) {
     $b->parent->product->readroles();
     if ( count($b->parent->product->role[PROD_ROLE_MANAGER]) > 0 ) {
       $b->setSolver(current($b->parent->product->role[PROD_ROLE_MANAGER]));
     } else if ( count($b->parent->product->role[PROD_ROLE_MANAGER2]) > 0 ) {
       $b->setSolver(current($b->parent->product->role[PROD_ROLE_MANAGER2]));
     } else {
       $b->setSolver($current_user);
     }
   } else if ( $b->parent->getType() == "installation" ) {
     $b->setSolver($solver);
   } else {
     $b->setSolver($current_user);
   }
 }
 $b->setName($name);
 $b->setShort($short);
 $b->setState($state);
 $b->setClass($class);
 $dbconn->Begin("WORK");
 $msg .= $b->save();
 $dbconn->Commit("WORK");

 $gotourl = $b->getUrl();
 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location:". dirname(getBaseUrl()) ."/". $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: bug_ins.php,v 1.8.2.2 2004/07/30 18:24:44 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
