<?php
/**
 * Copyright 2001 - 2004 by Gero Kohnert
 *
 * @modulegroup group
 * @module group_show
 * @package group
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'pdf.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("group","show");
 loadmodule("group");
 loadlayout();
 
 function member_sort(&$a,&$b) {
   if ( $a->gettype() != $b->gettype() ) {
     return $a->gettype() > $b->gettype();
   }
   if ( ($b->gettype() == 'address') ) {
     return ($a->l_name < $b->l_name) ? -1 : 1;
   }
   if ( ($b->gettype() == 'company') ) {
     return ($a->name < $b->name) ? -1 : 1;
   }
 }
 

 /**
  * display a CRM group
  */
 class group_show extends layout {
   /**
    * display the info as PDF
    */
   Function pdf() {
     global $tutos,$lang;

     $pdf=new tutospdf($this->obj->dbconn);
     $pdf->Open();
     $pdf->setAuthor($this->obj->creator != -1 ? $this->obj->creator->getFullName():$lang['HistoryDeleted']);
     $pdf->setTitle($this->obj->getFullName());
     $pdf->setSubject($this->obj->getFullName());

	 $pdf->headtitle = $this->name;

     $pdf->AddPage();
     $h = 5;
     $pdf->SetFont('Arial','',8);
     $pdf->Cell(30,$h,$lang['GroupName'],0,0);
     $pdf->Cell(0,$h,$this->obj->name,0,1);
     $pdf->Cell(30,$h,$lang['GroupDesc'],0,0);
     $pdf->Cell(0,$h,$this->obj->desc,0,1);
     $pdf->Ln();

     $w  = array(35,25,40,50,0);
     $fs = array(7,7,7,7,7);
     $al = array('R','R','L','L','L');

     # Header
     $h = 8;
     $pdf->SetFont('Arial','B',$fs[0]);
     $pdf->Cell($w[0],$h, $lang['AdrName'],1,0,$al[0]);
     $pdf->SetFont('Arial','B',$fs[1]);
     $pdf->Cell($w[1],$h, $lang['Description'],1,0,$al[1]);
     $pdf->SetFont('Arial','B',$fs[2]);
     $pdf->Cell($w[2],$h, $lang['Phone'],1,0,$al[2]);
     $pdf->SetFont('Arial','B',$fs[3]);
     $pdf->Cell($w[3],$h, $lang['AdrEmail'],1,0,$al[3]);
     $pdf->SetFont('Arial','B',$fs[4]);
     $pdf->Cell($w[4],$h, $lang['AdrFax'],1,0,$al[4]);

     $pdf->Ln();

     foreach($this->obj->member as $i => $obj) {
       $x = $obj->gettype();

       $e = array();
       $f = array();
       $p = array();
       $d = array();
       $name = array();

       $name[] = $obj->getFullName();
       if ( ($x == "company") ||  ($x == "department") ){
         $obj->read_locs_data();
         foreach($obj->location as $l) {
		   if (count($obj->location) == 1) {
		     $loc = "";
		   } else {
		     $loc = " (".$l->lname.")";
		   }
           if ($l->email_1)
             $e[] = $l->email_1 .$loc;
           if ($l->email_2)
             $e[] = $l->email_2 .$loc;
           if ($l->fax_1)
             $f[] = $l->fax_1 .$loc;
           if ($l->phone_1)
             $p[] = $l->phone_1 .$loc;
           if ($l->phone_2)
             $p[] = $l->phone_2 .$loc;
         }
       }
       if ($x == "address"){
         $obj->read_locs_data();
         foreach($obj->location as $l) {
		   if (count($obj->location) == 1) {
		     $loc = "";
		   } else {
		     $loc = " (".$l->lname.")";
		   }
           if ($l->email_1)
             $e[] = $l->email_1 .$loc;
           if ($l->email_2)
             $e[] = $l->email_2 .$loc;
           if ($l->fax_1)
             $f[] = $l->fax_1 .$loc;
           if ($l->phone_1)
             $p[] = $l->phone_1 .$loc;
           if ($l->phone_2)
             $p[] = $l->phone_2 .$loc;
           if ($l->desc1)
             $d[] = $l->desc1 .$loc;
         }
       }
       if ($x == "team") {
         $name = array();
         $name[] = $lang[$x];
         $name[] = $obj->getFullName();
       }

       $max = 0;
       $max = max($max,count($name));
       for ($i=0;$i<$max;$i++) {
         $h = 5;
         $border = "LR";
         if ($i == 0) {
           $border .= "T";
           $h += 1;
         }
         if ($i == ($max-1)) {
           $border .= "B";
           $h += 1;
         }
         #name
         $pdf->SetFont('Arial','',$fs[0]);
         $pdf->Cell($w[0],$h, (isset($name[$i]) ? $name[$i]:" "),$border,0,$al[0]);
         #desc
         $pdf->SetFont('Arial','',$fs[1]);
         $pdf->Cell($w[1],$h, (isset($d[$i]) ? $d[$i]:" "),$border,0,$al[1]);
         #phone
         $pdf->SetFont('Arial','',$fs[2]);
         $pdf->Cell($w[2],$h,(isset($p[$i]) ? $p[$i] : " "),$border,0,$al[2]);
         #email
         $pdf->SetFont('Arial','',$fs[3]);
         $pdf->Cell($w[3],$h, (isset($e[$i]) ? $e[$i] : " "),$border,0,$al[3]);
         #fax
         $pdf->SetFont('Arial','',$fs[4]);
         $pdf->Cell($w[4],$h, (isset($f[$i]) ? $f[$i] : " "),$border,0,$al[4]);

         $pdf->Ln();
       }
     }
     $pdf->Close();
     $data = $pdf->buffer;
     Header("Content-Type: application/pdf");
     if(headers_sent()) {
       Fatal_Error('Some data has already been output to browser, can\'t send PDF file');
     }
     Header("Content-Disposition: inline; filename=\"". $this->obj->name .".pdf\"");
     Header("Content-Description: Upload from TUTOS" );
     Header('Content-Length: '.strlen($data));
     echo $data;
     return;
   }
   /**
    * the data display part
    */
   Function info() {
     global $tutos,$lang;

     $this->obj->read_member();
     if ( count($this->obj->member) > 0 ) {
       @reset ($this->obj->member);
       usort($this->obj->member,"member_sort");
	 }

     if ($this->format == 'pdf') {
       Header("Expires: 0");
       Header("Pragma: no-cache");
       $this->pdf();
       return;
     }
     echo $this->DataTableStart();
     echo "<tr>\n";
     echo " <th colspan=\"6\">". sprintf($lang['Showing'],myentities($this->obj->getFullName())) ."</th>\n";
     echo $this->user->layout->showGuiIcons("<th align=\"right\">","</th>",$this->obj,$this->obj,array("mod","del"),false);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['createdby']);
     echo $this->showdata($this->obj->creator != -1 ? $this->obj->creator->getLink():$lang['HistoryDeleted'],2);
     echo $this->showfield($lang['atDateTime']);
     echo $this->showdata($this->obj->creation->getDateTime(),3);

     echo "</tr><tr>\n";
     echo $this->showfield($lang['GroupName']);
     echo $this->showdata(myentities($this->obj->name),6);

     echo "</tr><tr>\n";
     echo $this->showfield($lang['GroupDesc']);
     echo $this->showdata(myentities($this->obj->desc),6);

     echo "</tr>\n";

     # References to modules
     show_module_infolists($this->user,$this->obj,7);

     if ( count($this->obj->member) > 0 ) {
       $first = true;
       echo "<tr>\n";
       echo $this->showfield($lang['GroupMember']);
       echo "<th>". $lang['AdrName']."</th>";
       echo "<th colspan=\"2\">". $lang['Description']."</th>";
       echo "<th>". $lang['AdrEmail']."</th>";
       echo "<th>". $lang['Phone']."</th>";
       echo "<th>". $lang['AdrFax']."</th>";
       echo "</tr>\n";
       $line = 1;
       while( list ($i,$f) = @each ($this->obj->member)) {
         echo $this->OverviewRowStart($line);
         echo "<td>&nbsp;</td>";
         $f->read_locs_data();
         $cnt =  count($f->location);
         if ( $cnt > 0 ) {
           @reset($f->location);
           echo "<td valign=\"top\" rowspan=\"". $cnt ."\">". $this->obj->member[$i]->getLink() ."</td>\n";
           $cnt2 = 0;
           while( list ($i2,$f2) = @each ($f->location)) {
             if ( $cnt2 > 0 ) {
               echo $this->OverviewRowEnd($line);
               echo $this->OverviewRowStart($line);
               echo "<td>&nbsp;</td>";
             }
             echo " <td>". $f2->lname ."&nbsp;</td>\n";
             echo " <td>". $f2->desc1 ."&nbsp;</td>\n";
             echo " <td>". asEmail($f2->email_1,$f2->email_1,$f2->getFullName());
             if ( $f2->email_2 != "" ) {
               echo "<br>". asEmail($f2->email_2,$f2->email_2,$f2->getFullName());
             }
             echo "&nbsp;</td>\n";
             echo " <td>". handle('phone',$f2,$f2->phone_1);
             if ( $f2->email_2 != "" ) {
               echo "<br>". handle('phone',$f2,$f2->phone_2);
             }
             echo "&nbsp;</td>\n";
             echo " <td>". handle('fax',$f2,$f2->fax_1) ."&nbsp;</td>\n";
             $cnt2++;
           }
         } else {
           echo "<td colspan=\"6\">". $this->obj->member[$i]->getLink() ."</td>\n";
         }
         echo $this->OverviewRowEnd($line++);
       }
     }
     echo $this->obj->getHistoryLink(7);
     echo $this->DataTableEnd();
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$tutos,$lang;

     $this->name = $lang['GroupDetail'];
     $this->obj = new group($this->dbconn);

     if ( isset($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
     }
     if ( ! $this->obj->see_ok() ) {
       $msg .= sprintf($lang['Err0022'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else if ( $this->obj->id < 0 ) {
       $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else {
       $this->name .=": ". $this->obj->getFullName();
     }
     # menu
     $m = group::getOverviewLink($this->user,$lang['Search']);
     $m[category][] = "obj";
     $this->addMenu($m);
     if ( $this->user->feature_ok(usegroups,PERM_NEW) ) {
       $x = array( url => "group/group_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['GroupCreate'],
                   category => array("group","new","obj")
                 );
       $this->addMenu($x);
     }
     if ( $this->obj->mod_ok() ) {
       $x = array( url => $this->obj->getModUrl(),
                   text => $lang['Modify'],
                   info => sprintf($lang['GroupModifyI'],$this->obj->getFullName()),
                   category => array("group","mod","obj")
                 );
       $this->addMenu($x);
     }
     if (($this->obj->id > 0) &&  $this->user->feature_ok(useprojects,PERM_SEE) ) {
       $x = array( url => "group/group_show.php?format=pdf&id=".$this->obj->id,
                   text => 'PDF',
                   info => 'PDF',
                   category => array("group","show","obj")
                 );
       $this->addMenu($x);
     }
     $x = $this->obj->getMailLink();
     $this->addMenu($x);
     add_module_addlinks($this,$this->obj);

     # add this page to the browsehistory of the users session
     $this->addtohistory();
   }
 }

 $l = new group_show($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: group_show.php,v 1.29.2.2 2004/12/05 09:48:58 gokohnert Exp $
    $Author: gokohnert $
-->