<?php
/**
 * Copyright 2004 by Gero Kohnert
 *
 * @modulegroup ADMIN
 * @module module_overview
 * @package BASE
 */
 include 'webelements.p3';
 include 'permission.p3';
 require_once 'db/table.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("admin","show");
 loadlayout();

function get_url_data($u) {
  global $tutos;

  $timeout = 10;
  $redir = "";
  $errno = "";
  $errstr = "";
  $r = array();
  $url = parse_url($u);
#  var_dump($url);
#  var_dump($u);
  if (!isset($tutos[proxyhost]) || empty($tutos[proxyhost]) ) {
    $fp = fsockopen($url['host'], "80", $errno, $errstr, $timeout);
  } else {
    $fp = fsockopen($tutos[proxyhost], $tutos[proxyport], $errno, $errstr, $timeout);
  }
  if (!$fp) return $errno." ".$errstr;  //just quit on error

  if (!isset($tutos[proxyhost]) || empty($tutos[proxyhost]) ) {
    fputs($fp, "GET " . $url['path'].(isset($url['query']) ? "?".$url['query']:"") . " HTTP/1.0\r\n".
               "Host: " . $url['host'] . "\r\n".
               "User-Agent: TUTOS\r\n".
               "Connection: close\r\n".
               "Cache-Control: no-cache\r\n".
               "Pragma: no-cache\r\n".
                "\r\n");
  } else {
    fputs($fp, "GET " . $u . " HTTP/1.0\r\n". 
               "Host: " . $url['host'] . "\r\n".
               "User-Agent: TUTOS\r\n".
               "Connection: close\r\n".
               "Proxy-Connection: close\r\n".
               "Accept-Encoding: deflate\r\n".
               "Cache-Control: no-cache\r\n".
               "Pragma: no-cache\r\n".
               "\r\n");
  }
  $head = true;
  while(!feof($fp)) {
    $x = fgets($fp, 8192);
    if (eregi("^location:(.*)",$x,$reg)) {
      $redir = trim($reg[1]);
      if (isset($url['query'])) {
        $redir .= "?". $url['query'];
      }

      break;
    }
#echo "+". $x ."+<br>\n";
    if ($head) {
      if ($x == "\r\n") {
        $head = false;
      }
      continue;
    }

    $r[] = $x;
  }
  fclose($fp);
  if ($redir != "") {
    $r = get_url_data($redir);
  }
  return $r;
}

 /**
  * display an overview of all TUTOS modules
  */
 class module_overview extends layout {
   /**
    * the data display part
    */
   Function info() {
     global $lang,$tutos;

     $line = 0;

     echo "This table was delivered from ". $this->url ."<br>";
     foreach($this->infos as $f) {
       echo $f ."<br>\n";
     }
     if (count($this->mods) == 0) {
       return;
     }
     $header = $this->mods[0];

     echo $this->OverviewTableStart();
     echo "<thead>\n";
     echo "<tr>\n";
     echo $this->orderHeader("","Action","");
     foreach($header as $f) {
       echo $this->orderHeader("",$f,"");
     }
     echo "</tr>\n";
     echo "</thead>\n";
     foreach($this->mods as $i => $m) {
       if ($i == 0) continue;

       echo $this->OverviewRowStart($line);

       echo "<td>\n";
       if (isset($tutos[modules][$m[0]])) {
         echo "<font color=\"green\">\n";
         echo "known";
         if ($tutos[ $tutos[modules][$m[0]]['perm'] ] != 0) {
           echo "<br>and <b>enabled</b>";
         }
       } else {
         echo "<font color=\"red\">\n";
         echo "unknown";
       }
       echo "</font>\n";
       echo "</td>\n";

       foreach($m as $f) {
         echo "<td>". urlReplace($f,1) ."&nbsp;</td>\n";
       }
       echo $this->OverviewRowEnd($line++);
     }

     echo $this->OverviewTableEnd();
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang,$tutos;

     $this->name = $lang['AdminModOverview'];
     $this->url = "http://www.tutos.org/modules.php";
     $this->mods = array();
     $this->infos = array();
     $this->url = addUrlParameter($this->url,"version=". $tutos[version]);
     $this->url = addUrlParameter($this->url,"format=plain");
     $r = get_url_data($this->url);

     foreach ($r as $line) {
       if (ereg("^@",$line)) {
         $this->infos[] = "<i>". substr($line,1) ."</i>";
         continue;
       }
       if (strlen(trim($line)) == 0) continue; 
#      echo "=".$line."=<br>";
       $this->mods[] = split('[|]',$line);
     }

#     $fd = fopen($this->url ,"R");
#     if ($r != 0 && $fd) {
#       while (!feof($fd)) {
#         $buffer = trim(fgets($fd, 4096));
#         if (0 == strlen($buffer)) continue;
#       }
#     } else {
#       $this->infos[] = "Missing data. allow_url_fopen is set to ". ini_get("allow_url_fopen");
#     }
#     fclose($fd);

   }
 }

 session_write_close();
 $l = new module_overview($current_user);
 $l->display();
 $dbconn->close();
?>
<!--
    CVS Info:  $Id: module_overview.php,v 1.5 2004/04/12 17:11:19 gokohnert Exp $
    $Author: gokohnert $
-->