<?php
/**
 * Copyright 2004 by Gero Kohnert
 *
 * display all contacsts of a product
 * i.e. all stakeholders (=role) together with some contact data
 *
 * @modulegroup product
 * @module product_contacts
 * @package product
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'product.pinc';
 include_once 'pdf.pinc';


 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product','show');
 loadlayout();

 /**
  * display a products contacts
  */
 class product_contacts extends layout {

   /**
    * display the info as PDF
    */
   Function pdf() {
     global $tutos,$lang;

     $pdf=new tutospdf($this->obj->dbconn);
     $pdf->Open();
     $pdf->setAuthor($this->obj->creator->getFullName());
     $pdf->setTitle($this->obj->getFullName());
     $pdf->setSubject($this->obj->getFullName());

     $pdf->headtitle = $this->name;

     $pdf->AddPage();

#     $h = 8;
#     $pdf->SetFont('Arial','',18);
#     $pdf->Cell(0,$h,$this->name,0,1);
#     $pdf->Ln();
     $h = 5;
     $pdf->SetFont('Arial','',8);
     $pdf->Cell(30,$h,$lang['ProdDesc'],0,0);
     $pdf->Cell(0,$h,$this->obj->description,0,1);
     $pdf->Cell(30,$h,$lang['ProdDesc1'],0,0);
     $pdf->Cell(0,$h,$this->obj->desc1,0,1);
     $pdf->Cell(30,$h,$lang['ProdDesc2'],0,0);
     $pdf->Cell(0,$h,$this->obj->desc2,0,1);
     $pdf->Ln();


     $w  = array(35,25,40,50,0);
     $fs = array(7,7,7,7,7);
     $al = array('R','R','L','L','L');

     # Header
     $h = 8;
     $pdf->SetFont('Arial','B',$fs[0]);
     $pdf->Cell($w[0],$h, $lang['AdrName'],1,0,$al[0]);
     $pdf->SetFont('Arial','B',$fs[1]);
     $pdf->Cell($w[1],$h, $lang['ProdRoles'],1,0,$al[1]);
     $pdf->SetFont('Arial','B',$fs[2]);
     $pdf->Cell($w[2],$h, $lang['Phone'],1,0,$al[2]);
     $pdf->SetFont('Arial','B',$fs[3]);
     $pdf->Cell($w[3],$h, $lang['AdrEmail'],1,0,$al[3]);
     $pdf->SetFont('Arial','B',$fs[4]);
     $pdf->Cell($w[4],$h, $lang['AdrFax'],1,0,$al[4]);
     $pdf->Ln();

     foreach ($lang['ProdRole'] as $role => $x ) {
       if ( isset($this->obj->role[$role]) && (count($this->obj->role[$role]) > 0) ) {
         foreach ($this->obj->role[$role] as $i => $r) {
           $x = $r->gettype();
           if ($x == "product") continue;

           $e = array();
           $f = array();
           $p = array();
           $rl = array();
           $name = array();

           $name[] = $r->getFullName();
           $rl[] = $lang['ProdRole'][$role];
           if ( !empty($this->obj->roledesc[$role][$i]) ) {
             $rl[] = " (". $this->obj->roledesc[$role][$i] .")";
           }
           if ($x == "address") {
             $r->read_locs_data();
             foreach($r->location as $l) {
               if (count($r->location) == 1) {
                 $loc = "";
               } else {
                 $loc = " (".$l->lname.")";
               }
               if ($l->email_1)
                 $e[] = $l->email_1 .$loc;
               if ($l->email_2)
                 $e[] = $l->email_2 .$loc;
               if ($l->fax_1)
                 $f[] = $l->fax_1 .$loc;
               if ($l->phone_1)
                 $p[] = $l->phone_1 .$loc;
               if ($l->phone_2)
                 $p[] = $l->phone_2 .$loc;
             }
           }
           if ($x == "company") {
             $r->read_locs_data();
             foreach($r->location as $l) {
               if (count($r->location) == 1) {
                 $loc = "";
               } else {
                 $loc = " (".$l->lname.")";
               }
               if ($l->email_1)
                 $e[] = $l->email_1 .$loc;
               if ($l->email_2)
                 $e[] = $l->email_2 .$loc;
               if ($l->fax_1)
                 $f[] = $l->fax_1 .$loc;
               if ($l->phone_1)
                 $p[] = $l->phone_1 .$loc;
               if ($l->phone_2)
                 $p[] = $l->phone_2 .$loc;
             }
           }
           if ($x == "team") {
             $name = array();
             $name[] = $lang[$x];
             $name[] = $r->getFullName();
           }
           if ($x == "department") {
             $r->read_locs_data();
             $name[] = " / ".$r->company->getFullName();
             foreach($r->location as $l) {
               if (count($r->location) == 1) {
                 $loc = "";
               } else {
                 $loc = " (".$l->lname.")";
               }
               if ($l->email_1)
                 $e[] = $l->email_1 .$loc;
               if ($l->email_2)
                 $e[] = $l->email_2 .$loc;
               if ($l->fax_1)
                 $f[] = $l->fax_1 .$loc;
               if ($l->phone_1)
                 $p[] = $l->phone_1 .$loc;
               if ($l->phone_2)
                 $p[] = $l->phone_2 .$loc;
             }
           }
           $max = 0;
           $max = max($max,count($name));
           $max = max($max,count($rl));
           $max = max($max,count($e));
           $max = max($max,count($f));
           $max = max($max,count($p));

           for ($i=0;$i<$max;$i++) {
             $h = 5;
             $border = "LR";
             if ($i == 0) {
               $border .= "T";
               $h += 1;
             }
             if ($i == ($max-1)) {
               $border .= "B";
               $h += 1;
             }
             #name
             $pdf->SetFont('Arial','',$fs[0]);
             $pdf->Cell($w[0],$h, (isset($name[$i]) ? $name[$i]:" "),$border,0,$al[0]);
             #role
             $pdf->SetFont('Arial','',$fs[1]);
             $pdf->Cell($w[1],$h, (isset($rl[$i]) ? $rl[$i]:" "),$border,0,$al[1]);
             #phone
             $pdf->SetFont('Arial','',$fs[2]);
             $pdf->Cell($w[2],$h,(isset($p[$i]) ? $p[$i] : " "),$border,0,$al[2]);
             #email
             $pdf->SetFont('Arial','',$fs[3]);
             $pdf->Cell($w[3],$h, (isset($e[$i]) ? $e[$i] : " "),$border,0,$al[3]);
             #fax
             $pdf->SetFont('Arial','',$fs[4]);
             $pdf->Cell($w[4],$h, (isset($f[$i]) ? $f[$i] : " "),$border,0,$al[4]);

             $pdf->Ln();
           }
         }
       }
     }
     $pdf->Close();
     $data = $pdf->buffer;
     Header("Content-Type: application/pdf");
     if(headers_sent()) {
       Fatal_Error('Some data has already been output to browser, can\'t send PDF file');
     }
     Header("Content-Disposition: inline; filename=\"". $this->obj->name .".pdf\"");
     Header("Content-Description: Upload from TUTOS" );
     Header('Content-Length: '.strlen($data));
     echo $data;
     return;
   }
   /**
    * display the info
    */
   Function info() {
     global $tutos,$lang;

     $this->obj->readroles();

     if ($this->format == 'pdf') {
       Header("Expires: 0");
       Header("Pragma: no-cache");
       $this->pdf();
       return;
     }
     echo $this->DataTableStart();
     echo "<tr>\n";
     echo " <th colspan=\"3\">". sprintf($lang['Showing'],$lang[$this->obj->getType()]) ."</th>\n";
     echo $this->user->layout->showGuiIcons("<th align=\"right\">","</th>",$this->obj,$this->obj,array("mod","del"),false);
     echo "</tr>\n";

     echo "<tr>\n";
     echo " <td>". $lang['createdby'] ."</td><td>". $this->obj->creator->getLink() ."</td>\n";
     echo " <td>". $lang['atDateTime'] ."</td><td>". $this->obj->creation->getLinkDateTime() ."</td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['ProdName']);
     echo $this->showdata(myentities($this->obj->name),3);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['ProdVersion']);
     echo $this->showdata(myentities($this->obj->version),3);
     echo "</tr>\n";

     echo $this->DataTableEnd();

     echo $this->OverviewTableStart();
     echo "<thead>\n";
     echo "<tr>\n";
     echo $this->orderHeader("",$lang['AdrName'],$this->link2);
     echo $this->orderHeader("",$lang['ProdRoles'],$this->link2);
     echo $this->orderHeader("",$lang['Phone'],$this->link2);
     echo $this->orderHeader("",$lang['AdrEmail'],$this->link2);
     echo $this->orderHeader("",$lang['AdrFax'],$this->link2);
     echo "</tr>\n";
     echo "</thead>\n";

     foreach ($lang['ProdRole'] as $role => $x ) {
       if ( isset($this->obj->role[$role]) && (count($this->obj->role[$role]) > 0) ) {
         foreach ($this->obj->role[$role] as $i => $r) {

           $x = $r->gettype();
           if ($x == "product") continue;

           $e = array();
           $f = array();
           $p = array();
           $n = array();

           $n[0] = $r->getLink();
           if ($x == "address") {
             $r->read_locs_data();
             foreach($r->location as $l) {
               $e[$l->lname."(1)"] = $l->email_1;
               $e[$l->lname."(2)"] = $l->email_2;
               $f[$l->lname] = $l->fax_1;
               $p[$l->lname."(1)"] = $l->phone_1;
               $p[$l->lname."(2)"] = $l->phone_2;
             }
           }
           if ($x == "company") {
             $r->read_locs_data();
             foreach($r->location as $l) {
               $e[$l->lname."(1)"] = $l->email_1;
               $e[$l->lname."(2)"] = $l->email_2;
               $f[$l->lname] = $l->fax_1;
               $p[$l->lname."(1)"] = $l->phone_1;
               $p[$l->lname."(2)"] = $l->phone_2;
             }
           }
           if ($x == "team") {
             $n[1] = $n[0];
             $n[0] = $lang[$x];
           }
           if ($x == "department") {
             $r->read_locs_data();
             $n = $r->getLink( $r->getFullName() ." / ". $r->company->getFullName() );
             foreach($r->location as $l) {
               $e[$l->lname."(1)"] = $l->email_1;
               $e[$l->lname."(2)"] = $l->email_2;
               $f[$l->lname] = $l->fax_1;
               $p[$l->lname."(1)"] = $l->phone_1;
               $p[$l->lname."(2)"] = $l->phone_2;
             }
           }

           echo "<tr>\n";
           echo " <td valign=\"top\">";
           $sep = "";
           foreach ($n as $m) {
             if ($m == "") continue;
             echo $sep . $m;
             $sep = "<br />";
           }
           echo "</td>\n";

           # Role
           echo " <td valign=\"top\">". $lang['ProdRole'][$role] ."\n";
           if ( !empty($this->obj->roledesc[$role][$i]) ) {
             echo  "<br />(". myentities($this->obj->roledesc[$role][$i]) .")";
           }
           echo " </td>\n";

           # Phone
           echo " <td valign=\"top\">";
           $sep = "";
           foreach($p as $m) {
             if ($m == "") continue;
             echo $sep . handle('phone',$n,myentities($m));
             $sep = "<br />";
           }
           echo "&nbsp;</td>\n";

           # Email
           echo " <td valign=\"top\">";
           $sep = "";
           foreach($e as $m) {
             if ($m == "") continue;
             echo $sep . AsEmail($m,$m,$n,$lang[$this->obj->gettype()] .":". $this->obj->getFullName());
             $sep = "<br />";
           }
           echo "&nbsp</td>\n";

           # Fax
           echo " <td valign=\"top\">";
           $sep = "";
           foreach($f as $m) {
             if ($m == "") continue;
             echo $sep . handle('fax',$n,myentities($m));
             $sep = "<br />";
           }
           echo "&nbsp;</td>\n";

           echo "</tr>\n";
         }
       }
     }

     echo $this->OverviewTableEnd();

   }
   /**
    * naviagtion
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang,$tutos;

     $this->name = $lang['ProductsContacts'];

     $this->link2 = "";
     $this->obj = new product($this->dbconn);
     if ( isset($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
     }
     if ( ! $this->obj->see_ok() ) {
       $msg .= sprintf($lang['Err0022'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else if ( $this->obj->id < 0 ) {
       $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else {
       $this->name .= ": ". $this->obj->getFullName();
     }

     # Menu      
     $x = product::getSelectLink($this->user,$lang['Search']);
     $x[category][] = "obj";
     $this->addMenu($x);
     if ( $this->user->feature_ok(useprojects,PERM_NEW) ) {
       $x = array( url => "product_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['ProdCreateInfo'],
                   category => array("product","new","obj")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->obj->mod_ok() ) {
       $x = array( url => $this->obj->getModURL(),
                   text => $lang['Modify'],
                   info => sprintf($lang['ProdModInfo'],$this->obj->getFullname()),
                   category => array("product","mod","obj")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->user->feature_ok(useprojects,PERM_SEE) ) {
       $x = array( url => "product_contacts.php?format=paper&id=".$this->obj->id,
                   text => $lang['Printable'],
                   info => $lang['PrintableInfo'],
                   category => array("product","show","obj")
                 );
       $this->addMenu($x);
     }
     if (($this->obj->id > 0) &&  $this->user->feature_ok(useprojects,PERM_SEE) ) {
       if ($tutos[fpdfpath] != "") {
         $x = array( url => "product_contacts.php?format=pdf&id=".$this->obj->id,
                     text => 'PDF',
                     info => 'PDF',
                     category => array("product","show","obj")
                   );
         $this->addMenu($x);
       }
     }

   }
 }

 $l = new product_contacts($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: product_contacts.php,v 1.5.2.3 2004/11/07 17:48:00 gokohnert Exp $
    $Author: gokohnert $
-->
