<?php
/**
 * Copyright 1999 - 2004 by Gero Kohnert
 * cloning option added by Michal Salaban 2003
 *
 * create a new product_role or modify/clone an existing one
 *
 * @modulegroup product
 * @module product_role_new
 * @package product
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';
 include_once 'product.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product','new');
 loadlayout();

 /**
  * change/modify a project role
  */
 class product_role_new extends layout {

   Function addRoleInput($rid, $count) {
     global $lang, $tutos,$table;

     echo "<tr>\n";
     if( $count == 1 )
       echo $this->showfieldc($lang['ProdRolesNew']);
     else
       echo "<td>&nbsp;</td>";

     echo " <td>\n";
     echo "  <select name=\"role".$count."\">\n";
     foreach ($lang['ProdRole'] as $role => $x) {
       # No Product Roles
       if ( $tutos[rolecheck][$role] == "p") {
         continue;
       }
       echo "   <option value=\"". $role ."\"".
     ($role == $tutos[defaultrole] ? " selected" : "") .">".
     myentities($lang['ProdRole'][$role]) ."</option>\n";
     }
     echo "  </select>\n";
     echo " </td>\n";

     $worker = getObject($this->dbconn,$rid);
     echo " <td>". $worker->getLink() ."</td>\n";
     echo " <input type=\"hidden\" id=\"r".$count."\" ".
       "name=\"r".$count."fn\" value=\"".$worker->getFullName()."\">\n";

     echo " <td><input id=\"r".$count."desc\" name=\"r".$count."desc\" value=\"". myentities($this->r1desc). "\" size=\"". min(30,$table['product2']['description'][size])."\" maxlength=\"". $table['product2']['description'][size] ."\"></td>\n";
     echo "</tr>\n";
   }

   /**
    * display the form
    */
   Function info() {
     global $tutos,$lang,$table;

     echo "<form name=\"productroleadd\" action=\"product_role_ins.php\" method=\"post\">\n";
     if ( $this->template ) {
       $this->addHidden("tplid",$this->obj->id);
     }
     else if ( $this->obj->id > 0 ) {
       $this->addHidden("id",$this->obj->id);
     }

     $this->addHidden("nbadd", count($this->rid));

     echo $this->DataTableStart();

     # Roles of peoples and teams etc.
     echo "<tr>\n";
     echo $this->showfield($lang['ProdRoles']);
     echo " <th>". $lang['ProdFunc'] ."</th><th>". $lang['AdrName'] ."</th><th>". $lang['ProdRoleDesc'] ."</th><th>".$lang['Remove']."</th>\n";
     echo "</tr>\n";

     # List all roles in this project
     if ( $this->obj->id > 0 ) {
       $n = 0;
       foreach ($lang['ProdRole'] as $role => $x) {
         if ( isset($this->obj->role[$role]) ) {
           foreach ($this->obj->role[$role] as $i => $o) {
             if ( $o->id < 1 ) {
               continue;
             }
             if ( $o->getType() == "product" ) {
               continue;
             }
             echo "<tr>\n";
             echo " <td>&nbsp;</td>\n";
             echo " <td>". $lang['ProdRole'][$role] ."</td>";
             echo " <td>". $o->getLink() ."</td>";
             echo " <td>". myentities($this->obj->roledesc[$role][$i]) ."&nbsp;</td>";
             $val = $o->id .",". $role;
             if ( ! isset($this->obj->rdel[$val]) ) {
               $this->obj->rdel[$val] = "";
             }
             echo " <td align=\"right\"><input id=\"del[]\" type=\"checkbox\" name=\"del[]\" value=\"". $val ."\"". $this->obj->rdel[$val] .">&nbsp;</td>";
             $n++;
             echo "</tr>\n";
           }
         }
       }
     }

     # Add input boxes for new selected people
     for($i=0; $i < count($this->rid); $i++)
       $this->addRoleInput($this->rid[$i], $i+1);

     echo "<tr>\n";
     if ( $this->obj->id != -1 ) {
       submit_reset(0,1,1,1,1,1);
     } else {
       submit_reset(0,-1,1,1,1,1);
     }
     echo "</tr>\n";

     echo $this->DataTableEnd();
     hiddenFormElements();
     echo $this->getHidden();
     echo "</form>\n";
     echo $this->setfocus("productroleadd.name");
     #echo $lang['FldsRequired'] ."\n";
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang,$tutos;

     $this->name = $lang['Product'];
     $this->obj = new product($this->dbconn);
     $this->r1desc = "";
     $this->r2desc = "";

     $this->template = false;

     if ( isset($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
       if ( $this->obj->id < 0 ) {
         $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
         $this->stop = true;
       }
       $this->name = sprintf($lang['ProdRoleAddT'],$this->obj->getFullName());
       $this->obj->readroles();
     } else if ( isset($_GET['tplid']) ) {
       $this->obj = $this->obj->read($_GET['tplid'],$this->obj);
       $this->template = true;
       if ( $this->obj->id < 0 ) {
         $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
         $this->stop = true;
       }
       $this->name = sprintf($lang['ProdCloneT'],myentities($this->obj->getFullName()));;
       $this->obj->readroles();
     } else {
       $this->name = $lang['ProdCreateT'];
       $this->obj->r1 = $this->user;
     }

     # Set the default role according to config file
     $this->obj->rsel1 = $tutos[defaultrole];

     # People Team Relations
     if( isset($_GET['rid']) ) {
       $rid = $_GET['rid'];

       if( is_array($rid) )
     $this->rid = $rid;

       $this->obj->r1 = new tutos_user($this->dbconn);
       $this->obj->r1 = $this->obj->r1->read($this->rid[0],$this->obj->r1);
     }
     
     if ( (($this->obj->id < 0) || ($this->template)) && !$this->user->feature_ok(useprojects,PERM_NEW) ) {
       $msg .= sprintf($lang['Err0054'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else if ( ! $this->obj->mod_ok() ) {
       $msg .= sprintf($lang['Err0024'],$lang[$this->obj->getType()]);
       $this->stop = true;
     }

     $x = product::getSelectLink($this->user,$lang['Search']);
     $x[category][] = "obj";
     $this->addmenu($x);
     if ( $this->user->feature_ok(useprojects,PERM_NEW) ) {
       $x = array( url => "product_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['ProdCreateInfo'],
                   category => array("product","new","obj")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->obj->del_ok() ) {
       $x = array( url => "product_del.php?id=".$this->obj->id,
                   text => $lang['Delete'],
                   info => sprintf($lang['ProdDelInfo'],
                   $this->obj->getFullname()),
                   category => array("product","del","obj"),
                   confirm => true
                 );
       $this->addMenu($x);
     }
     add_module_newlinks($this,$this->obj);
   }
 }

 $l = new product_role_new($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: product_role_new.php,v 1.5.2.2 2004/10/27 07:19:33 gokohnert Exp $
    $Author: gokohnert $
-->
