<?php
/*
 * Copyright 2004 by Gero Kohnert
 *
 * Reminder
 *
 * @modulegroup reminder
 * @module reminder_new
 * @package reminder
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("reminder","new");
 loadmodule("reminder");
 loadlayout();

 /**
  * change/modify a reminder
  */
 class reminder_new extends layout {
   /**
    * display the form
    */
   Function info() {
     global $tutos,$lang,$table;

     $o = array();
     echo "<form name=\"remindernew\" action=\"reminder_ins.php\" method=\"POST\">\n";
     echo $this->DataTableStart();
     echo "<tr>\n";
     echo " <th colspan=\"4\">".  sprintf($lang['Showing'],$lang[$this->obj->getType()])."</th>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderReference']);
     echo " <td colspan=\"3\">\n";
     if ($this->obj->id == -1) {
       echo $lang[$this->obj->ref->getType()] ." ". $this->obj->ref->getLink() ."\n";
       $this->addhidden("link_id",$this->obj->link_id);
       $what = $lang[$this->obj->ref->getType()] ." ". $this->obj->ref->getFullname();
     } else {
       echo "  <select name=\"link_id\">\n";
       foreach ($this->obj->plist as $i => $f) {
         echo "   <option value=\"". $i ."\"". ($i == $this->obj->link_id ? " selected>* ":">") . $lang[$f->getType()] .": ". myentities($f->getFullName()) ."</option>\n";
       }
       echo "  </select>\n";
       $this->addhidden("id",$this->obj->id);
       $what = $lang[$this->obj->ref->getType()];
     }
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderTo'],0,"to");
     echo " <td colspan=\"3\">\n";
     echo "  <select id=\"to\" name=\"to\">\n";
     foreach ($this->tolist as $i => $f) {
       echo "  <option value=\"". $i ."\">";
       if ($f->gettype() != "user") {
         echo $lang[$f->getType()]. " ";
       }
       echo myentities($f->getFullName());
       echo "</option>\n";
     }
     echo "  </select>\n";
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderAt'],0,"at_d");
     echo " <td colspan=\"1\"><input type=\"radio\" value=\"0\" name=\"type\" id=\"type\"". ($this->obj->type == REMINDER_SIMPLE ? " checked":"").">". $lang['ReminderDate'] ."</input></td>\n";
     echo " <td colspan=\"2\">\n";
     $this->obj->remind_date->EnterDateTime("at");
     echo " </td>\n";
     echo "</tr>\n";
     if (($this->obj->ref->gettype() == "address") || ($this->obj->ref->gettype() == "task") || ($this->obj->ref->gettype() == "product")) {
       echo "<tr>\n";
       echo $this->showfieldc("",0,"at_d");
       echo " <td colspan=\"1\"><input type=\"radio\" value=\"1\" name=\"type\" id=\"type\"". ($this->obj->type != REMINDER_SIMPLE ? " checked":"").">". $lang['ReminderEvent'] ."</input></td>\n";
       echo " <td colspan=\"2\">\n";
       echo " <select name=\"rd_type\" id=\"rd_type\">\n";
       if ($this->obj->ref->gettype() == "product") {
         echo " <option value=\"". REMINDER_PROD_START ."\"".($this->obj->type == REMINDER_PROD_START ? "selected":"").">\n";
         echo myentities($what .":". $lang['ProdStart']);
         echo " </option>\n";
         echo " <option value=\"". REMINDER_PROD_END ."\"".($this->obj->type == REMINDER_PROD_END ? "selected":"").">\n";
         echo myentities($what .":". $lang['ProdEnd']);
         echo " </option>\n";
         $o = array(-86400*7*2,-86400*7*1,-86400*2,-86400*1,-3600*2,-3600*1,0,
                    3600*1,3600*2,86400*1,86400*2,86400*7*1,86400*7*2);
       } else if ($this->obj->ref->gettype() == "task") {
         echo " <option value=\"". REMINDER_TASK_START ."\"".($this->obj->type == REMINDER_TASK_START ? "selected":"").">\n";
         echo myentities($what .":". $lang['TaskS_Start']);
         echo " </option>\n";

         echo " <option value=\"". REMINDER_TASK_END ."\"".($this->obj->type == REMINDER_TASK_END ? "selected":"").">\n";
         echo myentities($what .":". $lang['TaskS_End']);
         echo " </option>\n";

         echo " <option value=\"". REMINDER_REAL_TASK_START ."\"".($this->obj->type == REMINDER_REAL_TASK_START ? "selected":"").">\n";
         echo myentities($what .":". $lang['TaskReal'])." ".$lang['StartDate'];
         echo " </option>\n";

         echo " <option value=\"". REMINDER_REAL_TASK_END ."\"".($this->obj->type == REMINDER_REAL_TASK_END ? "selected":"").">\n";
         echo myentities($what .":". $lang['TaskReal']." ".$lang['EndDate']);
         echo " </option>\n";

         $o = array(-86400*7*1,-86400*2,-86400*1,-3600*2,-3600*1,0,
                    3600*1,3600*2,86400*1,86400*2,86400*7*1);
       } else if ($this->obj->ref->gettype() == "address") {
         echo " <option value=\"". REMINDER_ADR_BIRTHDAY ."\"".($this->obj->type == REMINDER_ADR_BIRTHDAY ? "selected":"").">\n";
         echo myentities($what .":". $lang['AdrBirthday']);
         echo " </option>\n";
         $o = array(-86400*7*2,-86400*7*1,-86400*2,-86400*1,-3600*2,-3600*1,0);
       } else {
		   die($this->obj->ref->gettype());
	   }
       echo " </select>\n";
       if (count($o)) {
         echo " <br>\n";
         echo " <select name=\"offset\" id=\"offset\">\n";
         foreach ($o as $offset) {
           echo " <option value=\"". $offset ."\"".($offset == $this->obj->offset ? " selected=\"selected\"":"").">\n";
           echo myentities(reminder_offset_format($offset));
           echo " </option>\n";
         }
         echo " </select>\n";
       } else {
         $this->addhidden("offset",0);
	   }
       echo " </td>\n";
       echo "</tr>\n";
     } else {
       $this->addhidden("offset",0);
	 }

     #
     # Repeat
     #
	 $r = array(0,1800,3600,86400,86400*7);
     echo "<tr>\n";
     echo $this->showfield($lang['ReminderRepeat'],0,"repeat");
     echo " <td colspan=\"3\">\n";
     echo " <select name=\"repeat\" id=\"repeat\">\n";
     foreach ($r as $repeat) {
       echo "  <option value=\"". $repeat ."\"".($repeat == $this->obj->repeat ? " selected=\"selected\"":"").">\n";
       echo myentities(reminder_offset_format($repeat));
       echo " </option>\n";
	 }
     echo " </select><br>\n";
	 echo $lang['ReminderRepeatI'];
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderUseMail'],0,"usemail");
     echo " <td colspan=\"3\">\n";
     echo "<input id=\"usemail\" name=\"usemail\" type=\"checkbox\" value=\"1\"".($this->obj->usemail == 1 ? "checked":"")."></input>";
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderDesc'],0,"desc");
     echo $this->textarea("desc",5,$table['reminder']['description'][size],$this->obj->desc);
     echo "</tr>\n";

     # References to modules
     module_addforms($this->user,$this->obj,4);

     if ( $this->obj->mod_ok() != 0 ) {
       echo "<tr>\n";

       if ($this->obj->id > 0 ) {
         submit_reset(0,1,1,1,1,0);
       } else {
         submit_reset(0,-1,1,1,1,0);
       }

       echo "</tr>\n";
     }
     echo $this->DataTableEnd();
     hiddenFormElements();
     echo $this->getHidden();
     echo "</form>\n";
     echo $this->setfocus("remindernew.name");
     echo $lang['FldsRequired'] ."\n";
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $tutos,$lang,$msg;

     $this->obj = new reminder($this->dbconn);

     if ( isset($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
       $this->name = $lang['ReminderModify'] .": ". $this->obj->getFullName();
     } else {
       $this->name = $lang['ReminderCreate'];
     }

     if ( isset($_GET['link_id']) ) {
       $this->obj->link_id = StripSlashes($_GET['link_id']);
     }
     if ( isset($_GET['desc']) ) {
       $this->obj->desc = StripSlashes($_GET['desc']);
     }
     if ( isset($_GET['offset']) ) {
       $this->obj->offset = StripSlashes($_GET['offset']);
     }
     if ( isset($_GET['rd_type']) ) {
       $this->obj->type = StripSlashes($_GET['rd_type']);
     }

     $this->obj->read_reference();
     $this->obj->read_relations();

     $this->tolist[$this->obj->to_id] = &$this->obj->to;
     $this->tolist[$this->user->id] = &$this->user;
     foreach ( $this->user->teams as $i => $f ) {
       if ($f->use_ok()) {
         $this->tolist[$f->id] = &$f;
       }
       unset($f);
     }
     if ( ! $this->obj->mod_ok() ) {
       $msg .= sprintf($lang['Err0024'],$lang[$this->obj->getType()]);
       $this->stop = true;
     }
     # menu
     $m = reminder::getSelectLink($this->user,$lang['Search']);
     $m[category][] = "obj";
     $this->addMenu($m);

     if ( ($this->obj->id > 0) && $this->obj->del_ok() ) {
       $x = array( url => $this->obj->getDelURL(),
                   text => $lang['Delete'],
                   info => sprintf($lang['ReminderDeleteI'],$this->obj->getFullName()),
                   confirm => true,
                   category => array("note","del","obj")
                 );
       $this->addMenu($x);
     }
     add_module_newlinks($this,$this->obj);
   }
 }

 $l = new reminder_new($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: reminder_new.php,v 1.6.2.3 2004/12/05 09:48:59 gokohnert Exp $
    $Author: gokohnert $
-->
