<?php
/*
 * Copyright 2004 by Gero Kohnert
 *
 *   CVS Info:  $Id: reminder_overview.php,v 1.8.2.4 2004/12/05 09:48:59 gokohnert Exp $
 *   $Author: gokohnert $
 *
 * @modulegroup reminder
 * @module reminder_overview
 * @package reminder
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");

 include_once 'webelements.p3';
 include_once 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("reminder","overview");
 loadmodule("reminder");
 loadlayout();

 /**
  * display an overview of CRM groups
  */
 class reminder_overview extends layout {
   /**
    * the data display part
    */
   Function info() {
     global $tutos,$lang;

     $n = $this->result->numrows();
     echo $this->actionformStart("reminder_overview.php");
     echo $this->OverviewTableStart();
     echo "<thead>\n";
     echo "<tr>\n";
     echo $this->orderHeader("remind_date",$lang['ReminderAt'],$this->link2);
     echo $this->orderHeader("",$lang['ReminderTo'],$this->link2);
     echo $this->orderHeader("",$lang['ReminderDesc'],$this->link2);
     echo $this->orderHeader("",$lang['ReminderReference'],$this->link2);
     echo $this->orderHeader("",$lang['ReminderUseMail'],$this->link2);
     echo $this->orderHeader("",$lang['ReminderRepeat'],$this->link2);
     if ( $tutos[massupdate] == 1 ) {
       echo "  <th nowrap=\"nowrap\"><input type=\"checkbox\" name=\"checkit\" onclick=\"CheckAll2();\" /></th>\n";
     }
     echo "</tr>\n";
     echo "</thead>\n";
  
     if ( $this->start == -1 ) {
       $a = $n - $tutos[maxshow];
       $end = $n;
       $this->start = $a;
     } else {
       $a = $this->start;
       $end = $this->start + $tutos[maxshow];
     }
  
     $line = 1;
     while ( ($a < $n) && ($a < $end) ) {
       $c = new reminder($this->dbconn);
       $c->read_result($this->result,$a);
       $c->read_reference();
       $a++;
       if ( ! $c->see_ok() ) {
         continue;
       }
       echo $this->OverviewRowStart($line);
       echo "<td valign=\"top\">". $c->getLink($c->remind_date->getDateTime()) ."</td>\n";
       echo "<td valign=\"top\">". ($c->to >0 ? $c->to->getLink(): $lang['HistoryDeleted']) ."</td>\n";
       echo "<td valign=\"top\">". myentities($c->desc) ."&nbsp;</td>\n";
       echo "<td valign=\"top\">". $lang[$c->ref->getType()] ." ". $c->ref->getLink();
	   if ($c->type != REMINDER_SIMPLE) {
	     echo "<br />\n". $c->getEventName();
	   }
       echo "&nbsp;</td>\n";

       echo "<td valign=\"top\">";
       if ($c->usemail > 0 ) {
         echo $lang['yes'];
         echo ":&nbsp;". $c->fired_at->getDateTimeShort();
       } else {
         echo $lang['no'];
       }
       echo  "</td>\n";

       echo "<td valign=\"top\">". reminder_offset_format($c->repeat). "</td>\n";

       if ( $tutos[massupdate] == 1 ) {
         echo " <td align=\"center\">\n";
         if ( $c->mod_ok() ) {
           echo "<input name=\"mark[]\" type=\"checkbox\" value=\"". $c->id ."\">\n";
         } else {
           echo "-\n";
         }
         echo "</td>\n";
       }
       echo $this->OverviewRowEnd($line++);
     }
  
     echo $this->list_navigation($this->link1,6+$tutos[massupdate],$this->start,$a,$n);
     if ( $tutos[massupdate] == 1 ) {
       echo $this->UpdateRowStart(5);
       echo sprintf($lang['withmarked'],$lang['Reminders']);
       echo "&nbsp;<select name=\"action\">\n";
       echo " <option value=\"-1\" selected>". $lang['ActionNil'] ."</option>\n";
       echo " <option value=\"-2\">". $lang['Delete'] ."</option>\n";
       echo " <option value=\"-4\">". $lang['AclModify'] ."</option>\n";
       echo "</select>\n";
       echo $this->UpdateRowEnd(2);
     }
     echo $this->OverviewTableEnd();
     echo $this->actionformEnd("reminder_overview.php");
     $this->result->free();
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * action via massupdate
    */
   Function action() {
     global $lang,$msg;

     if ( $_GET['action'] == -2 ) {
       $this->dbconn->Begin("WORK");
       foreach ($_GET['mark'] as $key => $val) {
         $b = new reminder($this->dbconn);
         $b = $b->read($val,$b);
         if ( $b->id != $val ) {
           continue;
         }
         if ( $b->del_ok() ) {
           $msg .= $lang['Delete'].":". $b->getFullName() ."<br />";
           $msg .= $b->delete();
         } else {
           $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]) ."<br />\n";
         }
         unset($b);
       }
       $this->dbconn->Commit("WORK");
       return;
     }
     if ( $_GET['action'] == -4 ) {
       $this->redirect = "../". acl_action();
       return;
     }
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang,$tutos;

     $this->name = $lang['ReminderOverview'];

     if ( ! $this->user->feature_ok(usereminder,PERM_SEE) ) {
       $msg .= sprintf($lang['Err0022'],"'". $this->name ."'");
       $this->stop = true;
     }

     $this->link1 = "reminder/reminder_overview.php";
     $this->q = "SELECT * FROM ". $this->dbconn->prefix ."reminder";
     $pre = " WHERE ";

     if ( isset($_GET['name']) && ($_GET['name'] != "*") && ($_GET['name'] != "") ) {
       $this->q .= $pre . $this->dbconn->Like("description",$_GET['name']);
       $pre = " AND ";
       $this->link1 = addUrlParameter($this->link1,"name=". UrlEncode($_GET['name']));
     }

     if ( isset($_GET['link_id']) ) {
       if (false == is_numeric($_GET['link_id'])) {
         $msg .= sprintf($lang['Err0012'],"link_id",$_GET['link_id']);
         $this->stop = true;
       }
       $this->q .= " ". $pre ." link_id = ".$_GET['link_id'];
       $pre = " AND ";
       $this->link1 = addUrlParameter($this->link1,"link_id=". $_GET['link_id']);
     }

     check_dbacl($this->q, $this->user->id);

     # sorting
     $xxx = "";
     $this->link2 = $this->link1;
     order_parse($this->q,$this->link1,$xxx,$xxx,"remind_date");
     # display default sortorder
     if (!isset($_GET['xf'])) {
       $_GET['xf'] = "remind_date";
       $_GET['xo'] = 1;
     }

     $this->result = $this->dbconn->Exec($this->q);
     $n = $this->result->numrows();

     if ( 0 == $n) {
       $this->result->free();
       $this->redirect = "reminder_select.php?msg=". UrlEncode($lang['Err0048']);
     }

   }
 }

 $l = new reminder_overview($current_user);
 $l->display();
 $dbconn->Close();
?>
