<?php
/**
 * Copyright 2004 by Gero Kohnert
 *
 * @modulegroup reminder
 * @module reminder_show
 * @package reminder
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("reminder","show");
 loadmodule("reminder");
 loadlayout();
 
 /**
  * display a reminder 
  */
 class reminder_show extends layout {
   /**
    *
    */
   Function info() {
     global $lang,$tutos;

     echo $this->DataTableStart();
     echo "<tr><th colspan=\"3\">". $lang['Reminder'] ."</th>";
     echo $this->user->layout->showGuiIcons("<th align=\"right\">","</th>",$this->obj,$this->obj,array("mod","del"),false);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['createdby']);
     echo $this->showdata($this->obj->creator->getLink(),1);
     echo $this->showfield($lang['atDateTime']);
     echo $this->showdata($this->obj->creation->getDateTime(),1);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['ReminderReference']);
     echo $this->showdata($lang[$this->obj->ref->getType()]." ". $this->obj->ref->getLink(),3);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderTo']);
     echo $this->showdata( ($this->obj->to >0 ? $this->obj->to->getLink(): $lang['HistoryDeleted']),3);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderAt']);
     echo $this->showdata($this->obj->remind_date->getLinkDateTime(),3);
     echo "</tr>\n";

     if ($this->obj->type != REMINDER_SIMPLE) {
       echo "<tr>\n";
       echo $this->showfieldc($lang['ReminderType']);
       echo $this->showdata($lang[$this->obj->ref->getType()] ." ". $this->obj->ref->getLink() .": ". $this->obj->getEventName(false),3);
       echo "<tr>\n";
       if ($this->obj->offset != 0) {
         echo "</tr>\n";
         echo $this->showfieldc($lang['ReminderOffset']);
         echo $this->showdata(reminder_offset_format($this->obj->offset),3);
         echo "</tr>\n";
       }
     }
     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderRepeat']);
     echo $this->showdata(reminder_offset_format($this->obj->repeat),3);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderUseMail']);
     echo $this->showdata( ($this->obj->usemail > 0 ? $lang['yes'] : $lang['no']),3);
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['ReminderDesc']);
     echo $this->showdata(myentities($this->obj->desc),3);
     echo "</tr>\n";

     # References to modules
     show_module_infolists($this->user,$this->obj,4);
     echo $this->obj->getHistoryLink(4);

     echo $this->DataTableEnd();
   }
   /**
    * navigation
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang;

     $this->name = $lang['ReminderDetail'];
     $this->obj = new reminder($this->dbconn);
     if ( isset($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
     } else {
       $msg .= $lang['Err0048'] ."<br>";
       $this->stop = true;
     }
     if ( ! $this->obj->see_ok() ) {
       $msg .= sprintf($lang['Err0022'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else if ( $this->obj->id < 0 ) {
       $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else {
       $this->obj->read_reference();
     }
     # menu
     $m = reminder::getSelectLink($this->user, $lang['Search']);
     $m[category][] = "obj";
     $this->addmenu($m);

     if ( ($this->obj->id > 0) && $this->obj->mod_ok() ) {
       $x = array( url => $this->obj->getModURL(),
                   text => $lang['Modify'],
                   info => sprintf($lang['ReminderModI'],$this->obj->getFullName()),
                   category => array("note","mod","obj")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->obj->del_ok() ) {
       $x = array( url => $this->obj->getDelURL(),
                   text => $lang['Delete'],
                   info => sprintf($lang['ReminderDeleteI'],$this->obj->getFullName()),
                   confirm => true,
                   category => array("note","del","obj")
                 );
       $this->addMenu($x);
     }

     add_module_addlinks($this,$this->obj);
     # add this page to the browsehistory of the users session
     $this->addtohistory();
   }
 }

 $l = new reminder_show($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: reminder_show.php,v 1.5.2.2 2004/12/05 09:48:59 gokohnert Exp $
    $Author: gokohnert $
-->