<?php
/*
 * Copyright 1999 - 2004 by Gero Kohnert
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';
 include_once 'product.pinc';
 include_once 'task.pinc';
 include_once 'timetrack.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product','overview');
 loadlayout();

/**
 * find a row in the array $xarr for the given object $obj
 * from day $d1 till day $d2
 */
 function find_a_row(&$obj,&$xarr,$d1,$d2) {
   $r = -1;
   # increment row as long as one field is occupied
   do {
     $r++;
     $xsum = 0;
     for ($dd = $d1; $dd <= $d2; $dd++) {
       $xsum += ($xarr[$dd][$r] == 0 || $xarr[$dd][$r] == $obj->id  ? 0:1);
     }
#     echo myentities($obj->getFullName()) ." ". $r ." ". $xsum ."<br>";
   } while ($xsum != 0);
   return $r;
 }

 /**
  * show a overview of user-resources and appointments
  */
 class res_cal extends layout {
   /**
    * display the info
    */
   Function info() {
     global $tutos, $lang;

     echo $this->start->getLinkDateTime() ." - ". $this->end->getLinkDateTime();

     $month = Date("m/Y",$this->start->ts);
     $m = Date("m",$this->start->ts);
     $y = Date("Y",$this->start->ts);
     $cols = Date("j",$this->end->ts);

     echo $this->OverviewTableStart();
     echo "<tr>\n";
     echo " <th rowspan=\"2\">". $lang['AdrName'] ."</th>\n";
     echo " <th colspan=\"". $cols ."\">";

     $last = "res_cal.php?id=". $this->base->id ;
     $t = MkTime(0,0,0,($m -1),Date("d",$this->start->ts),$y);
     $last = addUrlParameter($last,"start=". Date("Ymd",$t));

     $next = "res_cal.php?id=". $this->base->id;
     $t = MkTime(0,0,0,($m +1),Date("d",$this->start->ts),$y);
     $next = addUrlParameter($next,"start=". Date("Ymd",$t));


     echo  makelink($last,$this->theme->getImage(left,'list'),$lang['ResCal']);
     echo  "&nbsp;". sprintf($lang['ResCalDetail'],menulink($this->base->getUrl(),myentities($this->base->getFullName())),$month) ."&nbsp;";
     echo  makelink($next,$this->theme->getImage(right,'list'),$lang['ResCal']);
     echo " </th>\n";
     echo "</tr>\n";
     echo "<tr>\n";
     $url = "app_new.php";
     $url = addUrlParameter($url,"people[]=".$this->base->id);
     for ($i = 1; $i <= $cols; $i++) {
       $t = MkTime(0,0,0,$m,$i,$y);
       $dinfo = GetDaysInfo($t);
       $link = addUrlParameter($url,"t=".sprintf("%04d%02d%02d",$y,$m,$i));
       echo " <td class=\"". $dinfo[color] ." monthday\">". makelink($link,sprintf("%02d",$i)) ."</td>\n";
     }
     echo "</tr>\n";

     $this->callist = array();
     appointment::readCal($this,$this->start,$this->end);
     $n3 = count($this->callist);


     $line = 0;
     foreach ($this->uids as $i => $f) {
       team::obj_read($f);

       $line++;

       $maxr = 0;
       $q1 = "SELECT t.* from ". $this->dbconn->prefix ."tasks t,". $this->dbconn->prefix ."taskworker w";
       $q1 = $q1 ." WHERE ( t.id = w.t_id) and (w.w_id =  ". $f->id ." or w.w_id = ". $this->base->id .")";
       $q1 = $q1 ."   AND ( (t.s_start < " . $this->dbconn->Date($this->end) ." AND t.s_start   >= " . $this->dbconn->Date($this->start) .") ";
       $q1 = $q1 ."    OR   (t.s_end < " . $this->dbconn->Date($this->end) ." AND t.s_end   >= " . $this->dbconn->Date($this->start) .") ";
       $q1 = $q1 ."    OR   (t.s_start < " . $this->dbconn->Date($this->start) ." AND t.s_end   >= " . $this->dbconn->Date($this->end) .") ";
       $q1 = $q1 ." )";
       $q1 = $q1 ." ORDER by t.s_start";

       $result1 = $this->dbconn->Exec($q1);
       $n1 = $result1->numrows();

       product::obj_read($f);
       $prolist = array();
       foreach (array(PROD_ROLE_MANAGER,PROD_ROLE_MANAGER2,PROD_ROLE_DEVEL) as $r) {
         if (isset($f->prolist[$r])) {
           $prolist = array_merge($prolist,$f->prolist[$r]);
         }
       }
       $n2 = count($prolist);
       echo "<!-- tasks $n1 | proj $n2 | apps $n3 | cols $cols -->\n";

       # Reset Fields  / Field index is day in month
       for ($r = 0; $r < ($n1 + $n2 + $n3) ; $r++) {
         for ($d = 1; $d <= $cols; $d++) {
           $xarr[$d][$r] = 0;
         }
       }
       $obj = array();

       # Fill Fields
       # Task Entries
       $a = 0;
       while ( $a < $n1 ) {
         $task = new task($this->dbconn);
         $task->read_result($result1,$a);

         if ( ! $task->see_ok() ) {
           $a++;
           continue;
         }
       # Mark all fields covered by this task
         $m1 = Date("m/Y",$task->s_start->ts);
         $d1 = Date("j",$task->s_start->ts);
         $m2 = Date("m/Y",$task->s_end->ts);
         $d2 = Date("j",$task->s_end->ts);
         if ( $m1 != $month ) {
           $d1 = 1;
         }
         if ( $m2 != $month ) {
           $d2 = $cols;
         }
         for ($d = $d1; $d <= $d2; $d++) {
           $r = find_a_row(&$task,&$xarr,$d1,$d2);
           $xarr[$d][$r] = $task->id;
           $obj[$task->id] = &$task;
           $maxr = Max($maxr,$r);
         }

         $a++;
         unset($task);
       }
       $result1->free();

       echo "<!-- $n1 $n2 $n3 $maxr -->\n";
       # Fill Fields
       # Project Entries
       $a = 0;
       foreach ($prolist as $prod) {
#         if ( ! $prod->see_ok() ) { continue; }
         if ( $prod->p_start->notime == 1 ) { continue; }
         if ( $prod->p_end->notime == 1 ) { continue; }
         if ( $prod->p_end->ts < $this->start->ts ) { continue; }
         if ( $prod->p_start->ts > $this->end->ts ) { continue; }

         if ( $prod->p_start->ts < $this->start->ts ) {
           $d1 = 1;
         } else {
           $d1 = Date("j",$prod->p_start->ts);
         }

         if ( $prod->p_end->ts > $this->end->ts ) {
           $d2 = $cols;
         } else {
           $d2 = Date("j",$prod->p_end->ts);
         }

         
         foreach(array_unique(array_keys($prod->role)) as $i) {
           if (isset($prod->role[$i][$f->id])) {
             $prod->myrole = $i;
             break;
           }
         }
#        echo "<br>X". $m1." ". $d1 ." ". $m2 ." ". $d2 ." ". $prod->getFullName() ."<br>";
         for ($d = $d1; $d <= $d2; $d++) {
           $r = find_a_row(&$prod,&$xarr,$d1,$d2);
           $xarr[$d][$r] = $prod->id;
           $obj[$prod->id] = &$prod;
           $maxr = Max($maxr,$r);
         }

         $a++;
         unset($prod);
       }
       echo "<!-- $n1 $n2 $n3 $maxr -->\n";


       # Calendar Entries
       foreach($this->callist as $i => $app) {
         $found = 0;
         foreach($app->participant as $i2 => $f2) {
           if ( $i2 == $f->id ) {
             $found++;
             break;
           }
           if ( $i2 == $this->base->id ) {
             $found++;
             break;
           }
           foreach($f->teamlist as $i3 => $f3) {
             if ($i2 == $i3) {
               $found++;
               break;
             }
           }
         }
         if ( $found == 0 ) {
           $a++;
           continue;
         }
         # Mark all fields covered by this task
         $m1 = Date("m/Y",$app->start->ts);
         $d1 = Date("j",$app->start->ts);
         $m2 = Date("m/Y",$app->end->ts);
         $d2 = Date("j",$app->end->ts);
         if ( $m1 != $month ) {
           $d1 = 1;
         }
         if ( $m2 != $month ) {
           $d2 = $cols;
         }
		 if ($app->repeat == APP_NOREP) {
           # non repeating
           for ($d = $d1; $d <= $d2; $d++) {
             $r = find_a_row(&$app,&$xarr,$d1,$d2);
             $obj[$app->id] = &$this->callist[$i];
             $xarr[$d][$r] = $app->id;
             $maxr = Max($maxr,$r);
           }
         } else {
           # repeating => check every day
           for ($d = 1; $d <= $cols; $d++) {
             $t = MkTime(0,0,0,$m,$d,$y);
			 $day = new DateTime(0);
			 $day->setDateTimeTS($t);
			 if($app->inside($day)) {
               $r = find_a_row(&$app,&$xarr,$d,$d);
               $obj[$app->id] = &$this->callist[$i];
               $xarr[$d][$r] = $app->id;
               $maxr = Max($maxr,$r);
			 }
		   }
		 }
       }

       echo $this->OverviewRowStart($line);

       if ( ($n1 + $n2 + $n3) > 0 ) {
         echo "  <td title=\"". myentities($f->getShortname()) ."\" rowspan=\"". ($maxr +1) ."\">". $f->getLink($f->getShortname()) ."</td>\n";
       } else {
         echo "  <td title=\"". myentities($f->getShortname()) ."\">". $f->getLink($f->getShortname()) ."</td>\n";
         echo "  <td colspan=\"". $cols ."\">&nbsp;</td>\n";
       }
       echo "<!-- $n1 $n2 $n3 $maxr -->\n";

       for ($r = 0; $r < ($n1 + $n2 + $n3); $r++) {
         if ( $r > $maxr ) {
           continue;
         }

         if ( $r > 0 ) {
           echo $this->OverviewRowStart($line);
         }
         $day = 1;
         $old = $xarr[$day][$r];
         $colspan = 0;

         while ( $day <= $cols ) {
           if ( $xarr[$day][$r] != $old ) {

             echo "  <td colspan=\"".$colspan ."\"";
             if ( $old <= 0 ) {
               echo ">&nbsp;";
             } else {
               echo " title=\"".myentities($obj[$old]->getFullName())."\"";
               if ( $obj[$old]->getType() == "task" ) {
                 echo " class=\"task". $obj[$old]->state ."\">".$obj[$old]->getLink() ." (". $obj[$old]->volume ." ". $lang['hours'] .")" ;
               } else if ( $obj[$old]->getType() == "product" ) {
                 echo " class=\"prodrole". $obj[$old]->myrole ."\">".$obj[$old]->getLink() ." (". $obj[$old]->p_start->getDate() ." - ". $obj[$old]->p_end->getDate() .")" ;
               } else {
                 if ( $obj[$old]->descr == "" ) {
                   $obj[$old]->descr = $lang['AppLoc'][$obj[$old]->outside];
                 }
                 if ( $obj[$old]->mod_allow == 3 ) {
                   $class = "privapp";
                 } else {
                   $class = "app".$obj[$old]->outside;
                 }
                 echo " class=\"". $class ."\">". $obj[$old]->getLink(myentities($obj[$old]->descr)) ;

               }
             }
             echo "</td>\n";
             $old = $xarr[$day][$r];
             $colspan = 1;
           } else {
             $colspan++;
           }
           $day++;
         }
         if ( $old <= 0 ) {
           echo "  <td colspan=\"". $colspan ."\">&nbsp;</td>\n";
         } else {
           echo "  <td colspan=\"".$colspan ."\"";
           if ( $old <= 0 ) {
             echo ">&nbsp;";
           } else {
             echo " title=\"".myentities($obj[$old]->getFullName())."\"";
             if ( $obj[$old]->getType() == "task" ) {
               echo " class=\"task". $obj[$old]->state ."\">".$obj[$old]->getLink() ." (". $obj[$old]->volume ." ". $lang['hours'] .")";
             } else if ( $obj[$old]->getType() == "product" ) {
                 echo " class=\"prodrole". $obj[$old]->myrole ."\">".$obj[$old]->getLink() ." (". $obj[$old]->p_start->getDate() ." - ". $obj[$old]->p_end->getDate() .")" ;
             } else {
               if ( $obj[$old]->mod_allow == 3 ) {
                 $class = "privapp";
               } else {
                 $class = "app".$obj[$old]->outside;
               }
               echo " class=\"". $class ."\">".$obj[$old]->getLink(myentities($obj[$old]->descr)) ;
             }
           }
           echo "</td>\n";
         }
         echo $this->OverviewRowEnd($line);
       }
     }
     echo $this->OverviewTableEnd();
   }
   /**
    * naviagte
    */
   Function navigate() {
     global $lang;

     echo "<tr><td>";

     $link = addUrlParameter($this->link,"format=paper");
     echo menulink($link,$lang['Printable'],$lang['PrintableInfo']);

     echo "</td></tr>";
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang;

     $this->name = $lang['ResCal'];
     $this->link = "res_cal.php";
     $this->uids = array();
     if ( isset($_GET['id']) ) {
       $this->link = addUrlParameter($this->link,"id=".$_GET['id']);
       if ($_GET['id'] == 0 ) {
         $this->base = new team($this->dbconn);
         $this->base = $this->base->read(0,$this->base);
       } else {
         $this->base = GetObject($this->dbconn,$_GET['id']);
       }
       if ( $this->base->gettype() == "team" ) {
         $this->base->read_member();
         @reset($this->base->member);
         while ( list ($i,$f) = @each ($this->base->member) ) {
           $this->uids[$i] = $f;
         }
       } else if ( $this->base->gettype() == "address" ) {
         $this->uids[$this->base->id] = $this->base;
       } else if ( $this->base->gettype() == "user" ) {
         $this->uids[$this->base->id] = $this->base;
       }
     } else {
       $this->base = $this->user;
       $this->uids[$this->base->id] = $this->base;
     }
     if ( isset($_GET['start']) ) {
       $this->start = new DateTime($_GET['start']);
     } else {
       $t = MkTime(0,0,0,Date("m"),1,Date("Y"));
       $this->start = new DateTime();
       $this->start->setDateTimeTS($t);
     }
     if ( isset($_GET['end']) ) {
       $this->end = new DateTime($_GET['end']);
     } else {
       $t = $this->start->getTimeStamp();
       $x = Date("m",$t);
       while ( $x == Date("m",$t) ) {
         $t += 86400;
       }
       $t = MkTime(0,0,0,Date("m",$t),Date("d",$t),Date("Y",$t));
       $t -= 1;
       $this->end = new DateTime();
       $this->end->setDateTimeTS($t);
     }
     $this->link = addUrlParameter($this->link,"start=".Date("Ymd",$this->start->ts));
     $this->link = addUrlParameter($this->link,"end=".Date("Ymd",$this->end->ts));

   }
 }

 $l = new res_cal($current_user);
 $l->display();
 $dbconn->Close();

?>
<!--
    CVS Info:  $Id: res_cal.php,v 1.34.2.3 2004/09/06 12:31:52 gokohnert Exp $
    $Author: gokohnert $
-->