<?php
/**
 *
 * Copyright 2001 - 2004 by Gero Kohnert
 *
 * @modulegroup watchlist
 * @package watchlist
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("watchlist","overview");
 loadmodule("watchlist");
 loadlayout();

 /**
  * show a overview of watchers
  */
 class watchlist_overview extends layout {
   /**
    * display the info
    */
   Function info() {
     global $lang,$tutos;

     $wl = new watchlist($this->dbconn);
     $r = $this->dbconn->Exec($this->q);
     $n = $r->numrows();
     if ( 0 == $n) {
       echo $this->error($lang['Err0048']);
       $r->free();
       return;
     }
 
     echo $this->actionformStart("watchlist_overview.php");
     echo $this->OverviewTableStart();
     echo "<thead>\n";
     if ( $this->id != -1 ) {
       $cols = 3 + $tutos[massupdate];
       echo "<tr>\n";
       echo " <th colspan=\"". $cols ."\">". $lang[$this->obj->getType()] ." ". menulink($this->obj->getUrl(),$this->obj->getFullName()) ."</th>\n";
       echo "</tr>\n";
     } else if ( $this->adr != -1 ) {
       $cols = 4 + $tutos[massupdate];
       echo "<tr>\n";
       echo " <th colspan=\"". $cols ."\">". $lang['Watcher'] ." ". menulink($this->obj->getUrl(),$this->obj->getFullName()) ."</th>\n";
       echo "</tr>\n";
     } else {
       $cols = 5 + $tutos[massupdate];
     }
     echo "<tr>\n";
     if ( $this->id == -1 ) {
       echo $this->orderHeader("","Typ",$this->link2);
       echo $this->orderHeader("","ID",$this->link2);
     }
     if ( $this->adr == -1 ) {
       echo $this->orderHeader("adr_id",$lang['Watcher'],$this->link2);
     }
     echo $this->orderHeader("creation",$lang['created'],$this->link2);
     echo $this->orderHeader("lastcall",$lang['WatchLastCall'],$this->link2);
     if ( $tutos[massupdate] == 1 ) {
       echo "  <th nowrap><input type=\"checkbox\" name=\"checkit\" onClick=\"CheckAll2();\"></th>\n";
     } else {
       echo $this->orderHeader("","&nbsp;",$this->link2);
     }
     echo "</tr>\n";
     echo "</thead>\n";

     if ( $this->start == -1 ) {
       $a = $n - $tutos[maxshow];
       $end = $n;
       $this->start = $a;
     } else {
       $a = $this->start;
       $end = $this->start + $tutos[maxshow];
     }

     $line = 0;
     while ( ($a < $n) && ($a < $end) ) {
       $oid = $r->get($a, "obj_id");
       $aid = $r->get($a, "adr_id");
       $obj = getObject($this->dbconn,$oid);
       $aobj = getObject($this->dbconn,$aid);

       $remove = false;
       echo $this->OverviewRowStart($line);
       if ( $this->id == -1 ) {
         if ( $obj == -1 ) {
           echo " <td nowrap align=\"right\">ID:". $oid ."</td>\n";
           echo " <td nowrap align=\"right\"><i>". makelink("history_show.php?id=".$oid,$lang['HistoryDeleted']) ."</i></td>\n";
           $remove = true;
         } else {
           echo " <td nowrap align=\"right\">". $lang[$obj->getType()] ."</td>\n";
           echo " <td nowrap align=\"right\">". $obj->getLink() ."</td>\n";
         }
       }
       if ( $this->adr == -1 ) {
         echo " <td nowrap align=\"right\">";
         if ( $aobj == -1 ) {
           echo "<i>". makelink("history_show.php?id=".$aid,$lang['HistoryDeleted']) ."</i>";
           $remove = true;
         } else {
           echo $aobj->getLink();
         }
         echo "</td>\n"; 
       }
       $d = $r->getDateTime($a, "creation");
       echo " <td nowrap align=\"right\">". $d->getDateTime() ."&nbsp;</td>\n";
       $d = $r->getDateTime($a, "lastcall");
       echo " <td nowrap align=\"right\">". $d->getDateTime() ."&nbsp;</td>\n";

 
       echo " <td align=\"center\">\n";
       if ( $tutos[massupdate] == 1 ) {
         if ( !$remove && (($this->user->id == $aid) || (($obj != -1 ) && $obj->mod_ok() )) ) {
           echo "<input name=\"mark[]\" type=\"checkbox\" value=\"". $oid .",". $aid ."\">\n";
         } else if ( $remove) {
           echo "removed";
           $wl->remove($oid,$aid);
         } else {
           echo "-";
         }
       } else {
         if ( !$remove && (($this->user->id == $aid) || (($obj != -1 ) && $obj->mod_ok() )) ) {
           $url = confirmlink("watchlist/watchlist_del.php?id=". $oid ."&adr=". $aid ."&gotourl=". $this->link1 ,$lang['Delete'],$lang['WatchDel']);
           echo $url ;
         } else if ( $remove) {
           echo "removed";
           $wl->remove($oid,$aid);
         } else {
           echo "-";
         }
       }
       echo "</td>\n";
       echo $this->OverviewRowEnd($line++);

       $a++;
     }

     echo $this->list_navigation($this->link1,$cols,$this->start,$a,$n);
     if ( $tutos[massupdate] == 1 ) {
       echo $this->UpdateRowStart($cols-1);
       echo sprintf($lang['withmarked'],"");
       echo "<select name=\"action\">\n";
       echo " <option value=\"-1\" selected>". $lang['ActionNil'] ."</option>\n";
       echo " <option value=\"-2\">". $lang['WatchDel'] ."</option>\n";
       echo "</select>\n";
       echo $this->UpdateRowEnd(2);
     }
     echo $this->OverviewTableEnd();
     echo $this->actionformEnd("watchlist_overview.php");
     $r->free();
   }
   /**
    * action
    */
   Function action() {
     global $msg,$lang;

     @reset($_GET['mark']);
     if ( $_GET['action'] == -2 ) {
       $this->dbconn->Begin("WORK");
       $w = new watchlist($this->dbconn);
       foreach ($_GET['mark'] as $val) {
         $a = split(',',$val);
#        echo "  ". $val ." ". $a[0] ." ". $a[1] ."<br>";
         $b = getObject($this->dbconn,$a[0]);
         if ( ! is_subclass_of($b,'tutos_base') ) {
           $msg .= "Unknown object: ". $a[0];
           continue;
         }
         if ( $b->id != $a[0] ) {
           $msg .= "Unknown object: ". $a[0];
           continue;
         }
         if ( ($this->user->id != $a[1]) && (! $b->mod_ok()) ) {
           $msg .= sprintf($lang['Err0024'],$lang[$b->getType()]) ." (". $b->getFullName() .")<br>";
           continue;
         }
#        echo " ". $b->getFullName();
         $msg .= $w->remove($a[0],$a[1]);
         unset($b);
       }
       $this->dbconn->Commit("WORK");
     }
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang;

     $this->name = $lang['WatchOverview'];
     $this->link1 = "watchlist/watchlist_overview.php";
     $this->filter = array();
     $this->adr = -1;
     $this->id = -1;

     $this->q = "SELECT * FROM ". $this->dbconn->prefix ."watchlist ";
     $pre = "WHERE ";

     if ( isset($_GET['adr']) && ($_GET['adr'] != "") ) {
       # overview of things a person is watching for
       $this->adr = $_GET['adr'];
       $this->q .=" " . $pre ." adr_id = ". $this->adr;
       $pre = "AND ";
       $this->link1 = addUrlParameter($this->link1,"adr=".$this->adr);
       $this->obj = getObject($this->dbconn,$this->adr);
       $this->name .= ": ". $lang['Watcher'] ." ". $this->obj->getFullName();
     }
     if ( isset($_GET['id']) && ($_GET['id'] != "") ) {
       # overview of persons watching for something
       $this->id = $_GET['id'];
       $this->q .= " " . $pre ." obj_id = ". $this->id;
       $pre = "AND ";
       $this->link1 = addUrlParameter($this->link1,"id=".$this->id);
       $this->obj = getObject($this->dbconn,$this->id);
       # check permission
       if ( ! $this->obj->mod_ok()) {
         $msg .= sprintf($lang['Err0022'],$lang[$this->obj->getType()]);
         $this->stop = true;
       }
     }

     check_dbacl( $this->q, $this->user->id, "obj_id");

     # sorting
     $this->link2 = $this->link1;
     $xxx = "";
     order_parse($this->q,$this->link1,$xxx,$xxx,"obj_id");
   }
 }

 $l = new watchlist_overview($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: watchlist_overview.php,v 1.24 2004/03/27 17:16:35 gokohnert Exp $
    $Author: gokohnert $
-->